%define daemon_user monitor
%if 0%{?suse_version}
%define htmlroot /srv/www/htdocs
%define httpconfdir apache2/conf.d
%define daemon_group www
%else
%define htmlroot /var/www/html
%define httpconfdir httpd/conf.d
%define daemon_group apache
%endif

Summary: A set of daemons to handle incoming logmessages and snmp traps.
Name: monitor-passive
Version: 3.2.4
Release: op5.1
Group: op5/monitor
License: op5 Immaterial Rights License
Vendor: op5 Development Team
Prefix: /opt/monitor/op5
Obsoletes: traphandler, loghandler
Source: %name-%version.tar.gz
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}

%if 0%{?sles_version}
Requires: apache2
%else
Requires: httpd
Requires: monitor-passive-logs
%endif
Requires: op5-monitor-user
Requires: monitor-passive-traps

%description
The op5 Passive Monitoring Tools is a set of daemons used to gather
status information from remote nodes via either the syslog mechanism
or the SNMP trap protocol.

%package traps
Version: 3.2.4
Release: op5.1
Group: op5/monitor
License: op5 Immaterial Rights License
Requires: monitor-passive
Requires: op5-trapper-collector
Summary: SNMP trap receiver

%description traps
op5 Passive Traps is used to gather status information from remote
nodes via the SNMP trap protocol.

%if 0%{?rhel}
%package logs
Version: 3.2.4
Release: op5.1
Group: op5/monitor
License: op5 Immaterial Rights License
Requires: monitor-passive
Requires: syslog
Summary: Syslog receiver

%description logs
op5 Passive Logs is used to gather status information from remote
nodes via the syslog mechanism.
%endif

%prep
%setup -q

%install
rm -rf %buildroot

DAEMON_USER=%daemon_user
DAEMON_GROUP=%daemon_group
HTMLROOT=%htmlroot
for file in $(find -type f|grep -v .git| grep -v passive.spec.in); do
	%{__sed} -i -e "s#@@HTMLROOT@@#${HTMLROOT}#g" $file
	%{__sed} -i -e "s#@@DAEMON_USER@@#${DAEMON_USER}#g" $file
	%{__sed} -i -e "s#@@DAEMON_GROUP@@#${DAEMON_GROUP}#g" $file
done

mkdir -p -m 755 %buildroot%prefix/passive
install -m 755 traphandler.sh %buildroot%prefix/passive

mkdir -p %buildroot%_sysconfdir/%httpconfdir
install -m 640 monitor-passive.conf.httpd %buildroot/etc/%httpconfdir/monitor-passive.conf

mkdir -p %buildroot%_sysconfdir/logrotate.d
install -m 600 passive.logrotate %buildroot/etc/logrotate.d/passive

mkdir -p -m 775 %buildroot%htmlroot/logs

%if 0%{?rhel}
mkdir -p %buildroot%_sysconfdir/rsyslog.d
install -m 640 monitor-passive-logs.conf.rsyslog %buildroot%_sysconfdir/rsyslog.d/monitor-passive-logs.conf
%endif

%if 0%{?rhel}
%post logs
rpm -q rsyslog >/dev/null
if [ $? -eq 0 ]; then
	/etc/init.d/rsyslog restart
else
	rpm -q op5-logserver >/dev/null
	if [ $? -gt 0 ]; then
		echo "This package requires that you have rsyslog installed to be able to recive remote syslog messages."
	fi
fi
%endif

%post traps
if ! grep -q traphandler.sh /opt/trapper/etc/collector.conf; then
echo 'traphandle default /opt/monitor/op5/passive/traphandler.sh' >> /opt/trapper/etc/collector.conf
fi

if [ -x /etc/init.d/collector ]; then
	/etc/init.d/collector stop || :
	/etc/init.d/collector start || :
fi

%postun traps
if [ $1 -eq 0 ]; then
	sed -ie '/traphandler.sh$/d' /opt/trapper/etc/collector.conf

	if [ -x /etc/init.d/collector ]; then
		/etc/init.d/collector stop || :
		/etc/init.d/collector start || :
	fi
fi

%files
%defattr(-,root,root)
%prefix/passive
%attr(775,%daemon_user,%daemon_group) %dir %htmlroot/logs
/etc/logrotate.d/passive
%attr(-,root,%daemon_group) /etc/%httpconfdir/monitor-passive.conf
%if 0%{?rhel}
%exclude /etc/rsyslog.d/monitor-passive-logs.conf
%endif

%files traps
%defattr(-,root,root)
%doc README.traphandler

%if 0%{?rhel}
%files logs
%defattr(-,root,root)
%attr(-,root,root) /etc/rsyslog.d/monitor-passive-logs.conf
%endif
